package kr.hews.helloservice;

import android.app.Service;
import android.content.Intent;
import android.os.Handler;
import android.os.IBinder;
import android.util.Log;

//Service  Ŭ
public class HelloService extends Service implements Runnable {

    //ID
    private int mStartId;
    //Ÿ̸ ֱ 3
    private static final int TIMER_PERIOD = 3 * 1000;	
    //óȸ
    private static final int COUNT = 10;
    
    //óī.  ȸ ó ϸ Ѵ
    private int mCounter;
    //Service 忡 õ Handler
    private Handler mHandler;
    // Frag
    private boolean mRunning;

    //Service   ȣ
    public void onCreate() {
        Log.i("HelloService","HelloService created.");
        super.onCreate();
        mHandler = new Handler();
        mRunning = false;
    }

    //Service ۿ䱸 ÿ ȣȴ
    // startID stopSelf   Ѵ
    public void onStart(Intent intent, int startId) {
        Log.i("HelloService","onStart id = " + startId);
        super.onStart(intent, startId);
        mStartId = startId;
        mCounter = COUNT;
        //̹  ƴϸ run޼ҵ带 ð Ŀ ⵿Ѵ
        if (! mRunning) {
            mHandler.postDelayed(this, TIMER_PERIOD);
            mRunning = true;
        }
    }	

    //Service  ÿ ȣȴ
    public void onDestroy() {
        Log.i("HelloService","HelloService stop.");
        mRunning = false;
        super.onDestroy();
    }

    //Service ó
    public void run() {
        Log.i("HelloService","run "+mCounter);

        if (! mRunning) {
        	//onDestory Service ϰ  ƹ͵   ʰ 
            Log.i("HelloService","run after destory");
            return;
        } else if (--mCounter <= 0) {
            // ȸ ϸ  Ѵ
            Log.i("HelloService","stop Service id = "+mStartId);
            stopSelf(mStartId);
        } else {
        	// ó  䱸Ѵ
            mHandler.postDelayed(this, TIMER_PERIOD);
        }
    }
    
    //Remote ޼ҵȣ  Ѵ
    //޼ҵȣ   쿡 null ȯѴ
	@Override
	public IBinder onBind(Intent arg0) {
		return null;
	}
}
