package kr.hews.intent;

import android.app.Activity;
import android.content.ContentUris;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.provider.Contacts;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class IntentActivity extends Activity implements OnClickListener{
    
    static final int[] BUTTONS = {
        R.id.action_dial,
        R.id.action_edit_contacts,
        R.id.action_view_geo,
        R.id.action_view_http,
        R.id.start_activity,
        R.id.start_activity_for_result
    };
	
    // 
    private static final String TAG = "IntentActivity";
    
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        // 
        for(int buttonId: BUTTONS) {
            Button button = (Button)findViewById(buttonId);
            button.setOnClickListener(this);
        }
    }
    // 
    public void onClick(View v) {
        int id = v.getId();
        if (id == R.id.action_dial) {
            sendDialIntent();
        } else if (id == R.id.action_edit_contacts) {
            sendEditContacts();
        } else if (id == R.id.action_view_geo) {
            sendViewGeo();
        } else if (id == R.id.action_view_http) {
            sendViewHttp();
        } else if (id == R.id.start_activity) {
            sendStartActivity();
        } else if (id == R.id.start_activity_for_result) {
            sendActivityForResult();
        } else {
        	Log.e(TAG, "Unkowon Button:"+v.toString());
        }
    }

    //Ʈ4-2  ȭȣ Ŵ Activity 
    private void sendDialIntent() {
    	Intent i = new Intent(Intent.ACTION_DIAL,
                              Uri.parse("tel:1234567890"));
    	startActivity(i);	
    }

    // 
    private void sendEditContacts() {
        //
        Uri uri = ContentUris.withAppendedId(
            Contacts.People.CONTENT_URI, 1);
    	Intent i = new Intent(Intent.ACTION_EDIT,uri);
    	startActivity(i);
    }

    // 
    private void sendViewGeo() {
        Intent i = new Intent(Intent.ACTION_VIEW,
                              Uri.parse("geo:0,0"));
    	startActivity(i);	
    }

    // 
    private void sendViewHttp() {
        Intent i = new Intent(Intent.ACTION_VIEW,
                              Uri.parse("http://www.google.com/"));
    	startActivity(i);	
    }

    //Ʈ4-3  ø̼ ȿ Activity 
    private void sendStartActivity() {
        Intent intent = new Intent(getApplicationContext(),
                                   LaunchedActivity.class);
        startActivity(intent);	
    }
    
//Ʈ4-5 StartActivityForResult  
   // Activity 䱸 ڵ
    private static final int LAUNCHED_ACTIVITY = 1;

    // Activity ϴ
    private void sendActivityForResult() {
        Intent intent = new Intent(getApplicationContext(),
                                   LaunchedActivity.class);
        // ° ڿ 䱸 ڵ带 ϴ
        startActivityForResult(intent, LAUNCHED_ACTIVITY);
    }

    @Override
    protected void onActivityResult(int requestCode,
                                    int resultCode,
                                    Intent data) {
        //ǵ   䱸 ڵ忡  Activity ߴ Ǵϴ
        if (requestCode == LAUNCHED_ACTIVITY) {
            TextView textView = (TextView)findViewById(R.id.result);
            if (resultCode != RESULT_OK) {
            	 // OK ƴ϶  ǥ
                textView.setText("Error.");
            } else {
            	//Ʈ  ؽƮ ȣ
                String result = data.getExtras().getString(
                    LaunchedActivity.TEXT_RESULT);
                //ؽƮ ؽƮ  ǥ
                textView.setText(result);
            }
        } else {
            super.onActivityResult(requestCode, resultCode, data);
        }
    }
}