/*
  ׸߱гΰ
*/
package kr.hews.picpuzzle;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.os.Debug;
import android.os.SystemClock;
import android.view.View;
import android.widget.Button;
import android.widget.Chronometer;
import android.widget.ImageButton;

//гΰ ȭ Ŭ
public class PicturePuzzle extends Activity {

	//(1)г ϴ ư
    static final int mImageButtons[] = {
        R.id.image_button1, R.id.image_button2, R.id.image_button3,
        R.id.image_button4, R.id.image_button5, R.id.image_button6,
        R.id.image_button7, R.id.image_button8, R.id.image_button9
    };

    //(2)гο ǥ ȭ ʱ
    static final int mInitialImages[] = {
        R.drawable.image1, R.drawable.image2, R.drawable.image3,
        R.drawable.image4, R.drawable.image5, R.drawable.image6,
        R.drawable.image7, R.drawable.image8, R.drawable.blank_image
    };

    /*(3)ȯ() г   ε
              0( ) г 1(߾   ) гΰ
      3( ߾) гΰ ϰ    {1, 3} ǥϰ 
    */
    static final int mNextPanelIndex[][] = {
        {1,3},   {0,4,2},   {1,5},
        {0,4,6}, {1,3,5,7}, {2,4,8},
        {3,7},   {4,6,8},   {7,5}
    };
        
    //(4)ư ϱ  Ʈѷ 迭
    PanelController mPanels[] = 
        new PanelController[mImageButtons.length];

    //ư ϱ  Ʈѷ
    class PanelController implements View.OnClickListener {
        ImageButton mButton;    //ϴ ư
        int mCurrentImage = 0;  //ǥϰ ִ ȭ󸮼ҽID
        final int mNext[];      //̵ г

        // ư, ȭ, ȯ   г 
        public PanelController(ImageButton button,
                               int resid,
                               final int next[]) {
            mButton = button;
            mNext = next;
            setImageResource(resid);
            mButton.setOnClickListener(this);
        }
        
        //(5)ο ȭ ҽID ϴ
        // ϰ ִ ȭ ҽID ȯϴ
        public int setImageResource(int resid) {
            int old = mCurrentImage;
            mCurrentImage = resid;
            mButton.setImageResource(resid);
            return old;
        }
        
        // ϰ ִ ȭ ҽID ȯϴ
        public int getImageResource() {
            return mCurrentImage;
        }
        
        //ǥϰ ִ  ȭ̶ true ȯϴ
        public boolean isBlank() {
            return mCurrentImage == R.drawable.blank_image;
        }
        
        //(6)ٸ гΰ ȭ ȯϴ
        public void swapImage(PanelController other) {
            int previous = other.setImageResource(mCurrentImage);
            setImageResource(previous);
        }

        //(7)ư TapǾ  
        public void onClick(View v) {
            for(int i=0; i<mNext.length; ++i) {
            	//ϴ г ȭ̶ ȭ ȯϴ
                if (mPanels[mNext[i]].isBlank()) {
                    swapImage(mPanels[mNext[i]]);
                    break;
                } 
            }
            if (isCompleted())
                complete();
        }
    }

    //(8) ø̼ ⵿  ȣǴ ޼ҵ
    @Override
    public void onCreate(Bundle icicle) {    	
        super.onCreate(icicle);
     
  
        setContentView(R.layout.main);
        createPanelController();
        setShuffleButtonListener();
            
    }
    
    //(9)  ư   PanelController ϴ
    private void createPanelController() {
        for(int i=0; i<mImageButtons.length; ++i) {
            ImageButton b = 
                (ImageButton)findViewById(mImageButtons[i]);
            mPanels[i] = new PanelController(b,
                                             mInitialImages[i],
                                             mNextPanelIndex[i]);
        }
    }
    
    //(10) г ȭ  ¿ ġϸ ϼ̶ Ǵϴ
    private boolean isCompleted() {
        for(int i=0; i<mInitialImages.length; ++i) {
            if (mInitialImages[i] != mPanels[i].getImageResource())
                return false;
        }
        return true;
    }

    //(11) г (shuffle)
    private void shuffle() {
        int size = mInitialImages.length;
        for(int i=0; i<size-1; ++i) {
            int swap = (int)(Math.random()*(size-i));
            mPanels[i].swapImage(mPanels[i+swap]);
        }
    }

    //(12)  ð ϰ Ÿ̸Ӹ ϴ
    private void startChronometer() {
        Chronometer c =
            (Chronometer)findViewById(R.id.chronometer);
        c.setBase(SystemClock.elapsedRealtime());
        c.start();
    }
    
    //(13) Ÿ̸Ӹ ϰ ð ȯϴ
    private long stopChronometer() {
        Chronometer c =
            (Chronometer)findViewById(R.id.chronometer);
        c.stop();
        return SystemClock.elapsedRealtime() - c.getBase();
    }
    
    //(14) Shuffle Button   ó
    private void setShuffleButtonListener() {
    	//shuffle Button ҷ
        Button b = (Button)findViewById(R.id.shuffle_button);
        //Tap  ȣǴ ʸ ϴ
        b.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                shuffle();
                startChronometer();
            }});
    }
    
    //(15)ϼ  ̾˷α׸ ǥϴ
    private void complete() {
        long msec = stopChronometer();
        AlertDialog.Builder b = new AlertDialog.Builder(this);
        b.setTitle(R.string.complete_title);
        b.setMessage(msec/1000 + " sec");
        b.setIcon(R.drawable.congratulations);
        b.setPositiveButton(
            R.string.complete_button,
            new DialogInterface.OnClickListener(){
                //ư  ̾˷α׸ ݴ´
                public void onClick(DialogInterface dialog,int which) {
                    dialog.dismiss();
                }
            });
        b.show();
    }
}