/*
Copyright (c) 2009 Hideo KINAMI

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 */

package kr.hews.hellorsrc;

import kr.hews.hellorsrc.R;
import android.app.Activity;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.view.View;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

public class HelloResource extends Activity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        TextView t = (TextView)findViewById(R.id.textview);
        int color = getResources().getColor(R.color.translucent_red);
        t.setBackgroundColor(color);
        String format = getResources().getString(R.string.format_string);
        String resultsText = String.format(format, 100, "String Result");
        t.setText(resultsText);
        
        CharSequence c = getText(R.string.styled_string);
        TextView t4 = (TextView)findViewById(R.id.textview4);
        t4.setText(c);
        t4.setText(c.toString());
        
        float dimen = getResources().getDimension(R.dimen.large_size);
        t4.setTextSize(dimen);
        
        Drawable green = getResources().getDrawable(R.drawable.opaque_green);
        t4.setBackgroundDrawable(green);
        
        Button b = (Button)findViewById(R.id.button);
        b.setOnClickListener(new View.OnClickListener() {

			public void onClick(View v) {
				ImageView i = (ImageView)findViewById(R.id.imageview);
				Animation anim = AnimationUtils.loadAnimation(HelloResource.this, R.anim.rotate);
		        TextView t = (TextView)findViewById(R.id.textview);
		        t.startAnimation(anim);
				anim.setRepeatMode(Animation.ABSOLUTE);
				i.startAnimation(anim);
			}
        });
    }
}