﻿/*
Copyright (c) 2009 Hideo KINAMI

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 */

// HelloListViewActivity.java
package kr.hews.hellolistview;

import java.util.ArrayList;

import android.app.ListActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;

// ListActivity을 계승하여 만든 
public class HelloListViewActivity extends ListActivity ( 

    // 목록보기에 표시할 데이터를 보유하는 어댑터 
    ArrayAdapter <String> mAdapter; 

    @ Override 
    public void onCreate (Bundle savedInstanceState) ( 
        super.onCreate (savedInstanceState); 

        // 뷰를 포함한 레이아웃 설정 
        setContentView (R.layout.main); 
         
        // 문자열이 포함된 목록 어댑터 생성 
        mAdapter = new ArrayAdapter <String> ( 
            getApplicationContext () 
            R.layout.list_row, 
            new ArrayList <String> ()); 
        // 어댑터 작업 설정 
        setListAdapter (mAdapter); 

        // 추가 버튼의 리스너를 등록 
        Button button = (Button) findViewById (R.id.add_button); 
        button.setOnClickListener (new View.OnClickListener () ( 
            public void onClick (View v) ( 
                addStringData (); 
            ))); 
    ) 

    //리스트에 새로운 요소를 추가 
    private void addStringData () ( 
        // 텍스트 상자에서 문자열을 분리하여 추가 
        EditText edit = (EditText) findViewById (R.id.edit_text); 
        mAdapter.add (edit.getText () toString ()); 
    ) 


}
