﻿/*
Copyright (c) 2009 Hideo KINAMI

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 */
 
// IHelloService AIDL

// 서비스 정의 패키지 이름
package kr.hews.bindservice;

// 인터페이스 정의
interface IHelloService {

    // 문자열을 추가합니다. 추가된 index 반환
    int addString(in String str);

    // 지정된 index 문자열을 읽을
    String getString(in int index);

    // 문자열 배열을 읽습니다. 값이 설정되지 않은 index가 있으면 false를 반환
    boolean getStrings(in int[] indexes, out String[] strs);

    // 지정된 start에서 end 1 개의 이전 index 문자열 목록을 읽음
    List<String> getStringList(in int start, in int end);
}
