﻿/*
Copyright (c) 2009 Hideo KINAMI

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 */

// HelloPreferencesReader.java
package jp.hews.helloprefreader;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.content.pm.PackageManager.NameNotFoundException;
import android.os.Bundle;
import android.widget.EditText;

public class HelloPreferencesReader extends Activity {

    // 액세스하는 응용 프로그램 패키지 이름
    public static final String PACKAGE_NAME = "kr.hews.hellopref";

    // 참조 환경 설정 이름
    public static final String COMMON_PREF = "CommonPref";
    // 내용에 맞도록 사용하는 키
    public static final String NAME = "Name";

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
    }

    // 작업이 포그라운드로되었을 때 데이터를 가져오기
    @Override
    protected void onResume() {
        super.onResume();

        try {			
            // 데이터를 가져오기 위해 컨텍스트 만들기
            Context other = createPackageContext(PACKAGE_NAME,0);

            // 환경 설정에서 값을 검색
            SharedPreferences common = 
                other.getSharedPreferences(
                    COMMON_PREF, 
                    MODE_WORLD_READABLE | MODE_WORLD_WRITEABLE);
            EditText name = (EditText)findViewById(R.id.name);
            name.setText(common.getString(NAME, ""));
        } catch (NameNotFoundException e) {
            e.printStackTrace();
        }
    }

    // 활동 포즈시 기본 설정으로 채우기
    @Override
    protected void onPause() {
        super.onPause();

        try {			
            // 데이터를 가져오기 위해 컨텍스트 만들기
            Context other = createPackageContext(PACKAGE_NAME,0);

            // 기본 값을 설정
            SharedPreferences common = 
                other.getSharedPreferences(
                    COMMON_PREF,
                    MODE_WORLD_READABLE | MODE_WORLD_WRITEABLE);
            EditText name = (EditText)findViewById(R.id.name);
            Editor editor = common.edit();
            editor.putString(NAME, name.getText().toString());
            editor.commit();
        } catch (NameNotFoundException e) {
            e.printStackTrace();
        }
    }

}
