﻿/*
Copyright (c) 2009 Hideo KINAMI

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 */

// HelloLocalFile.java
package kr.hews.hellolocalfile;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.widget.EditText;

// 로컬 파일에 액세스하는 샘플
public class HelloLocalFile extends Activity {

    // 만들 파일 이름
    private static final String MEMO_FILE="memo.txt";

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        InputStream in;
        try {
            // 로컬 파일의 검색 스트림 열기
            in = openFileInput(MEMO_FILE);
        } catch (FileNotFoundException e) {
            // 로컬 파일이 없는 경우
            // 리소스 파일 열기
            in = getResources().openRawResource(
                R.raw.initial_template);
        }
        EditText et = (EditText)findViewById(R.id.edit_text);
        try {
            // UTF - 8 텍스트 파일을 읽을
            BufferedReader reader = new BufferedReader(
                new InputStreamReader(in, "UTF-8"));
            String s;
            while( ( s = reader.readLine() ) != null ) {
                et.append(s);
                et.append("\n");
            }
            reader.close();
        } catch (IOException e) {
            Log.e("HelloLocalFile", e.toString());
        }
    }

    // 활동 포즈 때 파일 저장
    protected void onPause() {
        super.onPause();

        EditText et = (EditText)findViewById(R.id.edit_text);
        String s = et.getText().toString();
        if (s.length() == 0) {
            // 문자가 입력되어 있지 않으면 파일을 삭제
            deleteFile(MEMO_FILE);
            return;
        }
        try {
            // 로컬 파일의 입력 스트림 열기
            OutputStream out = 
                openFileOutput(MEMO_FILE, MODE_PRIVATE);
            PrintWriter writer = new PrintWriter(
                new OutputStreamWriter(out,"UTF-8"));
            writer.append(s);
            writer.close();
        } catch (IOException e) {
            Log.e("HelloLocalFile", e.getMessage());
        }
    }
}
