﻿/*
Copyright (c) 2009 Hideo KINAMI

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 */

// HelloMediaActivity.java
package kr.hews.hellomedia;

import android.app.Activity;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;

public class HelloMediaActivity extends Activity {

    private final View.OnClickListener mAudioButton =
        new View.OnClickListener() {

            public void onClick(View v) {
                Button b = (Button)v;
                if (mAudioPlayer == null) {
                    startAudio();
                    b.setText(R.string.stop_audio_label);
                } else {
                    stopAudio();
                    b.setText(R.string.play_audio_label);
                }	
            }
	};
	
    MediaPlayer mAudioPlayer;
    MediaPlayer mVideoPlayer;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        Button b;
        b = (Button)findViewById(R.id.play_audio);
        b.setOnClickListener(mAudioButton);
    }

    // 자원 Raw Directory MP3 파일 재생
    private void startAudio() {
        mAudioPlayer = 
            MediaPlayer.create(this, R.raw.shima_piano_blog284);
        mAudioPlayer.start();
    }

    // 플레이어를 중지
    private void stopAudio() {
        mAudioPlayer.stop();
        mAudioPlayer.release();
        mAudioPlayer = null;
    }
}
