﻿/*
Copyright (c) 2009 Hideo KINAMI

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
 */

package kr.hews.hellotelephone;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;

public class HelloTelephone extends Activity {
	
    private View.OnClickListener mCallButtonListener =
        new View.OnClickListener() {

            public void onClick(View v) {
                callPhone();
            }
	};
	
    private View.OnClickListener mDialButtonListener =
        new View.OnClickListener() {

            public void onClick(View v) {
                dialPhone();
            }
	};

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        Button button;
        button = (Button)findViewById(R.id.call_button);
        button.setOnClickListener(mCallButtonListener);
        button = (Button)findViewById(R.id.dial_button);
        button.setOnClickListener(mDialButtonListener);
    }


    // 지정된 번호의 전화 화면보기
    protected void dialPhone() {
        Intent intent = new Intent(Intent.ACTION_DIAL,
                                   Uri.parse("tel:123456"));
        startActivity(intent);
    }

    // 지정된 번호로 통화를 시작
    // android.permission.CALL_PHONE 설정이 필요
    protected void callPhone() {
        Intent intent = new Intent(Intent.ACTION_CALL,
                                   Uri.parse("tel:123456"));
        startActivity(intent);
    }
}
