﻿/*
   Copyright 2009 adamrocker

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
 */

// Decoder.java
package com.adamrocker.android.camezon;

import android.graphics.Bitmap;
import android.graphics.Rect;
import android.util.Log;
import com.google.zxing.MultiFormatReader;
import com.google.zxing.ReaderException;
import com.google.zxing.Result;
import static com.adamrocker.android.camezon.CameZonActivity.TAG;

// 이미지 byte 배열에서 바코드 분석
final public class Decoder {

    private final MultiFormatReader mMultiFormatReader;
    private Bitmap mResultBitmap;

    Decoder() {
        Log.i(TAG, "new Decoder");
        mMultiFormatReader = new MultiFormatReader();
    }

    
    // 분석 바코드 이미지를 얻을때 null을 반환 할지도 모른다
    Bitmap getResultBitmap0() {
        return mResultBitmap;
    }

     / **
     * 인수로 전달 화상 데이터에서 바코드 분석
     *
     * @ param data
     * 이미지 자료
     * @ param width
     * 이미지의 너비
     * @ param height
     * 이미지의 높이
     * @ param frame
     * 분석 영역
     * @ return
     * /

    Result decode(byte[] data, int width, int height, Rect frame) {
        Log.i(TAG, "decode");

        if (data == null) {
            return null;
        }

        Result rawResult = null;
        YUVMonochromeBitmapSource source = 
            new YUVMonochromeBitmapSource(data,width, height, frame);
        if (source != null) {
            try {
                rawResult = mMultiFormatReader.decodeWithState(source);
                mResultBitmap = source.renderToBitmap();
            } catch (ReaderException e) {
                // Ignore
            }
        }
        return rawResult;
    }
}
